{-| Module  : FiniteCategories
Description : Run all functors examples.
Copyright   : Guillaume Sabbagh 2022
License     : GPL-3
Maintainer  : guillaumesabbagh@protonmail.com
Stability   : experimental
Portability : portable

Run all functors examples. See results in the folder 
-}

module Math.Functors.Examples
(
    main
)
where
    import qualified Math.Functors.SetValued.Example        as SetValued
    import qualified Math.Functors.Adjunction.Example       as Adjunction
    import qualified Math.Functors.DiagonalFunctor.Example  as DiagonalFunctor
    import qualified Math.Functors.DataMigration.Example    as DataMigration
    import qualified Math.Functors.KanExtension.Example     as KanExtension
    import qualified Math.Functors.YonedaEmbedding.Example  as Yoneda
    
    -- | Run all examples of the project. See results in the folder OutputGraphViz.
    main = do
        SetValued.main
        KanExtension.main
        DataMigration.main
        Adjunction.main
        DiagonalFunctor.main
        Yoneda.main